-- | Definición del lenguaje.
module Lang where

-- | Los nombres de variables son strings, pero quizás 
-- querramos cambiarlo luego.
type Iden = String

-- | Expresiones enteras
data IntExpr = Const Int 
             | Var Iden
             | Neg IntExpr
             | IBin OpInt IntExpr IntExpr
             deriving Show

-- | Operadores binarios enteros, `Div` corresponde al cociente.
data OpInt = Plus | Minus | Times | Div | Mod
           deriving Show

-- | Expresiones booleanas
data Assert = AConst Bool
            | Not Assert
            | Rel OpRel IntExpr IntExpr
            | ABin OpBool Assert Assert
              deriving Show

-- | Operadores de relación (COMPLETAR)
data OpRel = Eq | NEq | Lt 
           deriving Show

-- | Operadores binarios booleanos (COMPLETAR)
data OpBool = And | Or
            deriving Show

-- | Comandos (COMPLETAR)
data Comm = Skip 
          | Assign Iden IntExpr
          | If Assert Comm Comm
          | Seq Comm Comm
          | While Assert Comm
            deriving Show

-- | Nombres cómodos (aka combinadores) para construcciones:
plus :: IntExpr -> IntExpr -> IntExpr
plus = IBin Plus

infixr 8 .+
-- | Versión con operadores
(.+) :: IntExpr -> IntExpr -> IntExpr
(.+) = IBin Plus
